//
//  HomeController.swift
//  CollectionViewCode
//
//  Created by MacBookPro on 2018. 2. 8..
//  Copyright © 2018년 MacBookPro. All rights reserved.
//

import UIKit

class MyCell: UICollectionViewCell{
    //부모 메서드 초기화 시켜줘야 한다.
    override init(frame: CGRect) {
        super.init(frame: frame)
        setupView()
    }
    
    required init?(coder aDecoder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }
    
    //셀에 이미지 뷰 객체를 넣어주기 위해서 생성
    let myImage: UIImageView = {
        let img = UIImageView()
        //자동으로 위치 정렬 금지
        img.translatesAutoresizingMaskIntoConstraints = false
        return img
    }()
    
    func setupView(){
        backgroundColor = .yellow
        //셀에 위에서 만든 이미지 뷰 객체를 넣어준다.
        addSubview(myImage)
        //제약조건 설정하기
        myImage.topAnchor.constraint(equalTo: self.topAnchor).isActive = true
        myImage.leftAnchor.constraint(equalTo: self.leftAnchor).isActive = true
         myImage.rightAnchor.constraint(equalTo: self.rightAnchor).isActive = true
          myImage.bottomAnchor.constraint(equalTo: self.bottomAnchor).isActive = true
        //myImage.widthAnchor.constraint(equalToConstant: 0).isActive = true
        //myImage.heightAnchor.constraint(equalToConstant: 0).isActive = true
    }
}




private let reuseIdentifier = "Cell"

//코드로 만들때는 uicollectionviewdatasource와 delegate 프로토콜을 상속 받을 필요가 없다.
class HomeController: UICollectionViewController, UICollectionViewDelegateFlowLayout {

    let images = ["a.jpg","b.jpg","c.jpg","a.jpg","b.jpg","c.jpg","a.jpg","b.jpg","c.jpg","a.jpg","b.jpg","c.jpg","a.jpg","b.jpg","c.jpg"]
    
    override func viewDidLoad() {
        super.viewDidLoad()
        collectionView?.backgroundColor = .white
        //셀 등록
        self.collectionView!.register(MyCell.self, forCellWithReuseIdentifier: reuseIdentifier)
    }
    //컬렉션뷰의 셀 개수
    override func collectionView(_ collectionView: UICollectionView, numberOfItemsInSection section: Int) -> Int {
        return images.count
    }

    //셀을 구숭하는 함수
    override func collectionView(_ collectionView: UICollectionView, cellForItemAt indexPath: IndexPath) -> UICollectionViewCell {
        //셀 참조 값 가져오기
        let cell = collectionView.dequeueReusableCell(withReuseIdentifier: reuseIdentifier, for: indexPath) as! MyCell
        
        //이미지 삽입
        cell.myImage.image = UIImage(named: images[indexPath.row])
        return cell
    }

    //셀크기
    func collectionView(_ collectionView: UICollectionView, layout collectionViewLayout: UICollectionViewLayout, sizeForItemAt indexPath: IndexPath) -> CGSize {
        let collWidth = collectionView.frame.width / 3 - 1
        return CGSize(width: collWidth, height: collWidth)
    }
    
    //위아래 간격
    func collectionView(_ collectionView: UICollectionView, layout collectionViewLayout: UICollectionViewLayout, minimumLineSpacingForSectionAt section: Int) -> CGFloat {
        return 1
    }
    //좌우간격
    func collectionView(_ collectionView: UICollectionView, layout collectionViewLayout: UICollectionViewLayout, minimumInteritemSpacingForSectionAt section: Int) -> CGFloat {
        return 1
    }
}
